﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace WG_NotesEditor
{
    public partial class Form1 : Form
    {
        Point cachedPosition = Point.Empty;
        CustomCreationFilter filter = new CustomCreationFilter();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            
            dt.Columns.Add("Column 2", typeof(string));
            dt.Columns.Add("Column 1", typeof(string));
            dt.Columns.Add("Column 3", typeof(string));
            dt.Columns.Add("Column 4", typeof(string));
            dt.Columns.Add("Notes", typeof(string));

            dt.Rows.Add(new object[] { "","","","",
                "This is the notes column. This column may contain a lot of text and we want to make the editor larger than the width of the column"});

            ultraGrid1.DataSource = dt;
            ultraGrid1.CreationFilter = filter;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["Notes"].AutoSizeEdit = DefaultableBoolean.True;
            e.Layout.Bands[0].Columns["Notes"].CellMultiLine = DefaultableBoolean.True;
            e.Layout.AutoFitStyle = AutoFitStyle.ExtendLastColumn;
            e.Layout.Bands[0].Columns["Notes"].Header.VisiblePosition = 4;
        }

        private void ultraGrid1_BeforeAutoSizeEdit(object sender, Infragistics.Win.UltraWinGrid.CancelableAutoSizeEditEventArgs e)
        {
            UltraGrid grid = sender as UltraGrid;
            if (grid == null)
                return;

            if (grid.ActiveCell == null)
                return;

            if (grid.ActiveCell.Column.Width < 400)
                e.StartWidth = 400;

            if (grid.ActiveCell.Column.CellMultiLine == DefaultableBoolean.True &&
                grid.ActiveCell.Row.Height < 100)
                e.StartHeight = 100;
            

            e.MaxHeight = 400;
            e.MaxWidth = 400;
        }


        private void ultraGrid1_AfterExitEditMode(object sender, EventArgs e)
        {
            filter.ElRect = Rectangle.Empty;
        }

    }
    
}
